//SqlDrivers.cpp
#include   <windows.h>
//#define    _UNICODE
#include   <tchar.h>
#include   <stdio.h>
#include   <string.h>
#include   <sql.h>                        //ODBC header file
#include   <sqlext.h>                     //ODBC header file
#include   "WinTypes.h"
#include   "SqlProcs.h"
#include   "Strings.h"
#include   "Main.h"
#include   "Sql.h"
#include   "Access.h"
#include   "SqlDrivers.h"
#if defined(MY_DEBUG)
    extern FILE* fp;
#endif


void btnSqlDrivers_OnClick(lpWndEventArgs Wea)
{
 TCHAR szDriver[256], szAttributes[256], lpBuffer[64];
 int i,iCount,iLnCt=1,iLine=0;
 HCURSOR hHourGlass, hArrow;
 String* ptrAttributes;
 TCHAR** ptrLines=NULL;
 short iLen1,iLen2;
 SQLHENV hEnvr;
 HWND hWnd=0;
 TCHAR* pCh;
 String s1;

 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Entering btnSqlDrivers_OnClick()\n"));
 #endif
 hHourGlass=LoadCursor(NULL,IDC_WAIT);
 SetClassLong(Wea->hWnd, GCL_HCURSOR, (LONG) hHourGlass);
 if(SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &hEnvr)!= SQL_ERROR)
 {
    SQLSetEnvAttr(hEnvr,SQL_ATTR_ODBC_VERSION,(SQLPOINTER)SQL_OV_ODBC3,SQL_IS_INTEGER);
    while(SQLDrivers(hEnvr,SQL_FETCH_NEXT,(SQLTCHAR*)szDriver,256,&iLen1,(SQLTCHAR*)szAttributes,256,&iLen2)!=SQL_NO_DATA)
    {
          iLnCt=iLnCt+2;
          pCh=szAttributes;
          for(i=0;i<iLen2;i++)
          {
              if(*pCh==0)
                 *pCh=_T(',');
              pCh++;
          }
          *--pCh=0;
          s1=szAttributes;
          iCount=s1.ParseCount(_T(','));
          iLnCt=iLnCt+iCount+2;
    };
    ptrLines=(TCHAR**)GlobalAlloc(GPTR,(iLnCt*sizeof(TCHAR*)));
    if(ptrLines)
    {
       _tcscpy(lpBuffer,_T("ODBC Database Drivers On Your System"));
       hWnd=CreateWindowEx(0,_T("frmOutput"),lpBuffer,WS_OVERLAPPEDWINDOW|WS_VSCROLL,700,150,350,475,HWND_DESKTOP,0,GetModuleHandle(NULL),NULL);
       SetWindowLong(hWnd,0,(long)iLnCt);
       SetWindowLong(hWnd,4,(long)ptrLines);
       while(SQLDrivers(hEnvr,SQL_FETCH_NEXT,(SQLTCHAR*)szDriver,256,&iLen1,(SQLTCHAR*)szAttributes,256,&iLen2)!=SQL_NO_DATA)
       {
             #if defined(MY_DEBUG)
                 _ftprintf(fp,_T("  szDriver     = %s\n\n"),szDriver);
             #endif
             ptrLines[iLine]=(TCHAR*)GlobalAlloc(GPTR,(_tcslen(szDriver)+1)*sizeof(TCHAR));
             if(!ptrLines[iLine])
             {
                MessageBox(Wea->hWnd,_T("Memory Allocation Error!"),_T("Not Good!"),MB_ICONERROR);
                ErrorMemFree(ptrLines,iLine);
                return;
             }
             _tcscpy(ptrLines[iLine],szDriver);
             iLine=iLine+2;
             pCh=szAttributes;
             for(i=0;i<iLen2;i++)
             {
                 if(*pCh==0)
                    *pCh=_T(',');
                 pCh++;
             }
             *--pCh=0;
             s1=szAttributes;
             iCount=s1.ParseCount(_T(','));
             ptrAttributes = new String[iCount];
             s1.Parse(ptrAttributes,_T(','));
             for(i=0;i<iCount;i++)
             {
                 #if defined(MY_DEBUG)
                     _ftprintf(fp,_T("  ptrAttributes[%u]=%s\n"),i,ptrAttributes[i].lpStr());
                 #endif
                 _stprintf(lpBuffer,_T("%s"),ptrAttributes[i].lpStr());
                 ptrLines[iLine]=(TCHAR*)GlobalAlloc(GPTR,(_tcslen(lpBuffer)+1)*sizeof(TCHAR));
                 if(!ptrLines[iLine])
                 {
                    MessageBox(Wea->hWnd,_T("Memory Allocation Error!"),_T("Not Good!"),MB_ICONERROR);
                    ErrorMemFree(ptrLines,iLine);
                    return;
                 }
                 _tcscpy(ptrLines[iLine],lpBuffer);
                 iLine++;
             }
             delete [] ptrAttributes;
             iLine=iLine+2;
             #if defined(MY_DEBUG)
                 _ftprintf(fp,_T("\n\n"));
             #endif
       };
    }
    if(hWnd)
       ShowWindow(hWnd,SW_SHOWNORMAL);
    SQLFreeHandle(SQL_HANDLE_ENV,hEnvr);
 }
 hArrow=LoadCursor(NULL,IDC_ARROW);
 SetClassLong(Wea->hWnd, GCL_HCURSOR, (LONG) hArrow);
 #if defined(MY_DEBUG)
     _ftprintf(fp,_T("Leaving btnSqlDrivers_OnClick()\n\n"));
 #endif
}
